
#define _GNU_SOURCE // required to use getline
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char* escapeHTML(char* htmlString);

int main(int argc, char** argv) {
  --argc; ++argv;
  char* lineBuf = NULL; 
  size_t lineBufLen = 0;
  while (getline(&lineBuf, &lineBufLen, stdin) != -1) {
    char* escaped = escapeHTML(lineBuf); 
    fputs(escaped, stdout);
    free(escaped);
  }
  return 0; 
}

// Basic function to escape a HTML string
// Inspired by an example in https://cwe.mitre.org/data/definitions/122.html
char *escapeHTML(char *htmlStr){
  int len = strlen(htmlStr);
  char *escapedHtml = (char*) malloc(len * 4);
  char* out = escapedHtml;
  for (const char* p = htmlStr; *p != '\0'; p++) {
    char* escapeSeq = NULL;
    switch(*p) {
      case '&':
        escapeSeq = "&amp;"; break;	
      case '<':
        escapeSeq = "&lt;"; break;	
      case '>':
        escapeSeq = "&gt;"; break;	
    }
    if (escapeSeq != NULL) {
      for (char* p2 = escapeSeq; *p2 != '\0'; p2++) {
        *out = *p2;
        ++out;	
      }
    } else {
      *out = *p;
      out++; 
    }
  }
  return escapedHtml;
}

